"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __accessCheck = (obj, member, msg) => {
  if (!member.has(obj))
    throw TypeError("Cannot " + msg);
};
var __privateGet = (obj, member, getter) => {
  __accessCheck(obj, member, "read from private field");
  return getter ? getter.call(obj) : member.get(obj);
};
var __privateAdd = (obj, member, value) => {
  if (member.has(obj))
    throw TypeError("Cannot add the same private member more than once");
  member instanceof WeakSet ? member.add(obj) : member.set(obj, value);
};
var __privateSet = (obj, member, value, setter) => {
  __accessCheck(obj, member, "write to private field");
  setter ? setter.call(obj, value) : member.set(obj, value);
  return value;
};

// src/index.ts
var src_exports = {};
__export(src_exports, {
  OSentry: () => OSentry,
  default: () => src_default
});
module.exports = __toCommonJS(src_exports);
var import_oro_functions = __toESM(require("oro-functions"), 1);
var Sentry = __toESM(require("@sentry/node"), 1);
var import_integrations = require("@sentry/integrations");
var DEFAULT_TAGS = ["projectname", "projectserver", "lang", "database", "action", "task"];
var _dsn, _status, _environment, _defaultOptions, _sentryOptions;
var _OSentry = class _OSentry {
  constructor({
    dsn,
    sentryDsn,
    environment,
    projectname,
    projectserver,
    defaultTags,
    autoInit = true,
    options = {}
  } = {}) {
    __privateAdd(this, _dsn, void 0);
    __privateAdd(this, _status, void 0);
    __privateAdd(this, _environment, void 0);
    __privateAdd(this, _defaultOptions, void 0);
    // @ts-ignore
    __privateAdd(this, _sentryOptions, void 0);
    __privateSet(this, _status, false);
    __privateSet(this, _dsn, sentryDsn || dsn);
    !import_oro_functions.default.isString(__privateGet(this, _dsn)) && __privateSet(this, _dsn, void 0);
    __privateSet(this, _environment, environment || "UNDEFINED");
    this.projectname = projectname;
    this.projectserver = projectserver;
    this.defaultTags = import_oro_functions.default.cloneObject(import_oro_functions.default.isArray(defaultTags) ? defaultTags : DEFAULT_TAGS);
    __privateSet(this, _defaultOptions, options);
    if (__privateGet(this, _dsn) && autoInit) {
      this.init();
    }
  }
  static getClient() {
    return Sentry;
  }
  get status() {
    return __privateGet(this, _status);
  }
  get environment() {
    return __privateGet(this, _environment);
  }
  getClient() {
    return _OSentry.getClient();
  }
  getOptions() {
    return __privateGet(this, _sentryOptions);
  }
  init(options = {}) {
    if (__privateGet(this, _status)) {
      return import_oro_functions.default.setResponseKO("OSentry is already init.");
    }
    const defaultOptions = import_oro_functions.default.cloneObject(__spreadValues(__spreadValues({}, __privateGet(this, _defaultOptions)), import_oro_functions.default.isObject(options) ? options : {}));
    !__privateGet(this, _dsn) && import_oro_functions.default.isString(defaultOptions.dsn) && __privateSet(this, _dsn, defaultOptions.dsn);
    defaultOptions.dsn && delete defaultOptions.dsn;
    import_oro_functions.default.isString(defaultOptions.environment) && __privateSet(this, _environment, defaultOptions.environment);
    defaultOptions.environment && delete defaultOptions.environment;
    if (!__privateGet(this, _dsn)) {
      console.error("OSentry: Sentry need DSN.");
      return import_oro_functions.default.setResponseKO("OSentry: Sentry need DSN.");
    }
    !import_oro_functions.default.isUndefined(defaultOptions.normalizeDepth) && !import_oro_functions.default.isNumeric(defaultOptions.normalizeDepth) && (defaultOptions.normalizeDepth = 11);
    const normalizeDepth = defaultOptions.normalizeDepth || 11;
    delete defaultOptions.normalizeDepth;
    __privateSet(this, _sentryOptions, __spreadValues({
      dsn: __privateGet(this, _dsn),
      tracesSampleRate: 0.5,
      environment: __privateGet(this, _environment),
      integrations: [new import_integrations.ExtraErrorData({ depth: normalizeDepth - 1 })],
      normalizeDepth
    }, defaultOptions));
    try {
      Sentry.init(__privateGet(this, _sentryOptions));
    } catch (error) {
      const msg = error.toString().split("\r\n")[0].replace(/\n/g, " ");
      return import_oro_functions.default.setResponseKO(`OSentry init failed: ${msg}`, { sentry: error });
    }
    __privateSet(this, _status, true);
    return import_oro_functions.default.setResponseOK();
  }
  sendResponse(response, inConsole = false) {
    var _c, _d;
    inConsole && console.log(response);
    if (!__privateGet(this, _status)) {
      console.error("OSentry: not init (sendResponse).");
      return import_oro_functions.default.setResponseKO("OSentry: not init (sendResponse).");
    }
    let extra = {};
    if (import_oro_functions.default.isObject(response)) {
      if (response.status) {
        const _a = import_oro_functions.default.cloneObject(response), { status: _ } = _a, rest = __objRest(_a, ["status"]);
        extra = rest;
      } else {
        const _b = import_oro_functions.default.cloneObject(response), { status: _, error } = _b, rest = __objRest(_b, ["status", "error"]);
        extra = __spreadValues(__spreadValues({}, error), rest);
      }
    }
    const msg = (extra == null ? void 0 : extra.msg) || (extra == null ? void 0 : extra.message) || "OSentry: response without msg";
    const level = (extra == null ? void 0 : extra.level) || ((response == null ? void 0 : response.status) ? _OSentry.LEVEL.INFO : _OSentry.LEVEL.ERROR);
    const tags = import_oro_functions.default.cloneObject((extra == null ? void 0 : extra.tags) || {});
    let user;
    if (import_oro_functions.default.isObject(extra)) {
      delete extra.msg;
      delete extra.level;
      delete extra.tags;
      extra.projectserver = (_c = extra.projectserver) != null ? _c : this.projectserver;
      extra.projectname = (_d = extra.projectname) != null ? _d : this.projectname;
      if (import_oro_functions.default.objIsNotEmpty(extra.user)) {
        user = import_oro_functions.default.cloneObjectWithKeys(extra.user, ["id", "username", "email"]);
      } else {
        delete extra.user;
      }
      for (const tagKey of this.defaultTags) {
        if (extra[tagKey] === void 0 || tags[tagKey] !== void 0) {
          continue;
        }
        tags[tagKey] = extra[tagKey];
        delete extra[tagKey];
      }
    }
    import_oro_functions.default.objIsEmpty(user) && (user = void 0);
    import_oro_functions.default.objIsEmpty(extra) && (extra = void 0);
    return this.captureMessage(msg, { level, tags, user, extra });
  }
  captureMessage(message, captureContext) {
    if (!__privateGet(this, _status)) {
      console.error("OSentry: not init (captureMessage).");
      return import_oro_functions.default.setResponseKO("OSentry: not init (captureMessage).");
    }
    const id = Sentry.captureMessage(message, captureContext);
    return import_oro_functions.default.setResponseOK({ event: { id, message, captureContext } });
  }
};
_dsn = new WeakMap();
_status = new WeakMap();
_environment = new WeakMap();
_defaultOptions = new WeakMap();
_sentryOptions = new WeakMap();
_OSentry.LEVEL = {
  LOG: "log",
  INFO: "info",
  DEBUG: "debug",
  WARNING: "warning",
  ERROR: "error",
  FATAL: "fatal"
};
var OSentry = _OSentry;
var src_default = OSentry;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  OSentry
});
